var init = {
	forms: {
		requestHeaders: {},
		smart_lndx_sdk: {}
	},
	script() {
		// if (Math.round(new Date()) >= 1651334400000) {
		// return false
		// }
		let pathName = window.location.pathname;
		switch (pathName) {
			case '/personcenter':
				init.startStudy();

				break;
		}
	},
	startStudy() {
		init.forms.requestHeaders = init.getRequestHeaders();
		init.forms.smart_lndx_sdk = JSON.parse(init.getLocalStorage('smart_lndx_sdk'));

		let setting = init.getEnableSetting();
		if (!setting) {
			return;
		}

		let myProjects = init.getMyProjects(setting.objId);
		if (myProjects.length === 0) {
			return;
		}

		$.each(myProjects, function (i, project) {
			let moduleCourses = init.getCourseList(project.csId);
			if (moduleCourses.length === 0) {
				return true;
			}

			let courses = [];
			moduleCourses.map(function(d){
				courses = courses.concat(d.childs);    
			});
			let resIds = courses.map(_ => _.resIds);

			let files = init.getCourseInfos(resIds);
			if (files.length === 0) {
				return true;
			}

			let successCount = 0;
			$.each(courses, function (j, course) {
				let file = files.find(_ => _.resId == course.resIds);
				if (file) {
					let result = init.updateLearningRecord(course.cptId, course.csId, course.resIds, file.resFiles[0].fileTimeLen);
					if (result) {
						successCount++;
					}
				}
				
				if(j === 2){
					return false;
				}
			});

			console.log(`项目《${project.csName}》共${courses.length}门课程，本次成功学习${successCount}门课程`);
		});
	},
	getEnableSetting() {  // 1、查询启用配置
		let result;
		let data = JSON.stringify({
			header: init.forms.requestHeaders,
			payload: {
				objType: '2'
			}
		});

		init.ajax({
			url: '/ahzjtrainadmininterface-service/common/anonymous/managePlatSetting/queryEnableSetting.do',
			data: data,
			operateType: '查询启用配置',
			success: function (res) {
				if (res.success != '1') {
					console.log(`查询启用配置失败：${res.message}`);
					return;
				}

				result = res.data;
			}
		});

		return result;
	},
	getMyProjects(tpId) {  // 2、查询我的学习 → 我的项目
		let result = [];
		let data = JSON.stringify({
			header: init.forms.requestHeaders,
			payload: {
				page: 1,
				rows: 999,
				sorts: 'lcsFinished=1&updateDate=0',
				tpId: tpId,
				custId: init.forms.smart_lndx_sdk.userId
			}
		});

		init.ajax({
			url: '/trainpronew-service/login/cgUserPlanClazzCourse/queryUserPlanCoursePage/v1.lyai',
			data: data,
			operateType: '查询我的项目',
			success: function (res) {
				if (res.success != '1') {
					console.log(`查询我的项目失败：${res.message}`);
					return;
				}

				result = res.data;
			}
		});

		return result;
	},
	getCourseList(csId) {  // 3、查询出所有的课程
		let courses = [];
		let data = JSON.stringify({
			header: init.forms.requestHeaders,
			payload: {
				csId: csId
			}
		});

		init.ajax({
			url: '/course-service/crsChapter/treeList/v1.lyai',
			data: data,
			operateType: '查询项目下所有课程',
			success: function (res) {
				if (res.success != '1') {
					console.log(`查询项目下所有课程失败：${res.message}`);
					return;
				}

				courses = res.data;
			}
		});

		return courses;
	},
	getCourseInfos(refIds) {  // 4、根据课程Id，查询出所有课程的学习总时长
		let files = [];
		let data = JSON.stringify({
			header: init.forms.requestHeaders,
			payload: {
				resId: refIds.join()
			}
		});

		init.ajax({
			url: '/resource-service/resResource/detail/v1.lyai',
			data: data,
			operateType: '查询课程学习总时长',
			success: function (res) {
				if (res.success != '1') {
					console.log(`查询课程学习总时长失败：${res.message}`);
					return;
				}

				files = res.data;
			}
		});

		return files;
	},
	updateLearningRecord(cptId, csId, resId, studyDuration) {  // 5、提交所有课程的学习进度
		let result = false;
		let data = JSON.stringify({
			header: init.forms.requestHeaders,
			payload: {
				cptId: cptId,
				csId: csId,
				resId: resId,
				startTime: 0,
				endTime: studyDuration,
				studyTime: 0,
				studyBreakpoint: studyDuration,
				studyUserId: init.forms.smart_lndx_sdk.userId
			}
		});

		init.ajax({
			url: '/resource-service/stdCustLearnRecord/learnSave/v1.lyai',
			data: data,
			success: function (res) {
				if (res.success != '1') {
					console.log(`提交课程学习进度失败：${res.message}；resId：${resId}`);
					return;
				}

				result = true;
			}
		});

		return result;
	},
	getParameter: function (name) {
		let reg = new RegExp("(^|&)" + name.toLowerCase() + "=([^&]*)(&|$)");
		let r = window.location.search.substr(1).match(reg);
		if (r != null) {
			return decodeURI(r[2]);
		}
		return null;
	},
	getCookie(key) {
		let cookies = document.cookie.split('; ');
		for (let i = 0; i < cookies.length; i++) {
			let keyAndValues = cookies[i].split('=');
			if (keyAndValues[0] == key) {
				console.log(keyAndValues[1]);
				return keyAndValues[1];
			}
		}
	},
	getTimeStamp() {
		return Math.round(new Date() / 1000);
	},
	getLocalStorage(item) {
		return localStorage.getItem(item);
	},
	getRequestHeaders() {
		let siteData_lenye = JSON.parse(init.getLocalStorage('siteData_lenye'));

		return {
			CLIENT_OS: 'O',
			REQ_TIME: init.getTimeStamp(),
			SESSION_TOKEN: init.getCookie('SESSION_TOKEN'),
			SITE_ID: siteData_lenye.siteId,
			UUID: init.getCookie('UUID')
		};
	},
	ajax(options) {
		let operateType = options.operateType ?? '';
		options = $.extend({
			url: '',
			type: 'post',
			data: null,
			dataType: 'json',
			async: false,
			success: function (res) { }
		}, options);

		$.ajax({
			url: `http://juheapi.zjzx.ah.cn${options.url}`,
			type: options.type,
			data: options.data,
			dataType: options.dataType,
			contentType: 'application/json',
			async: options.async,
			success: options.success,
			error: function () {
				console.log('error', `网络错误：${operateType}`);
			}
		});
	}
};
init.script();
